Bash-Snippets/qrify/qrify

150 lines
4.9 KiB
Plaintext
Raw Normal View History

#!/usr/bin/env bash
# Author: Linyos Torovoltos github.com/linyostorovovoltos
2017-08-02 19:01:57 +02:00
currentVersion="1.17.3"
2017-07-07 02:45:59 +02:00
multiline="0" # flag that indicates multiline option
2017-08-01 05:42:48 +02:00
## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredClient()
{
2017-08-01 05:42:48 +02:00
if command -v curl &>/dev/null; then
configuredClient="curl"
2017-08-01 05:42:48 +02:00
elif command -v wget &>/dev/null; then
configuredClient="wget"
2017-08-01 05:42:48 +02:00
elif command -v http &>/dev/null; then
configuredClient="httpie"
elif command -v fetch &>/dev/null; then
configuredClient="fetch"
else
2017-08-01 05:42:48 +02:00
echo "Error: This tool reqires either curl, wget, httpie or fetch to be installed." >&2
return 1
fi
}
2017-08-01 05:42:48 +02:00
## Allows to call the users configured client without if statements everywhere
httpGet()
{
case "$configuredClient" in
curl) curl -A curl -s "$@" ;;
wget) wget -qO- "$@" ;;
httpie) http -b GET "$@" ;;
2017-08-03 05:51:07 +02:00
fetch) fetch -q "$@" ;;
2017-08-01 05:42:48 +02:00
esac
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
2017-07-24 17:15:19 +02:00
repositoryName="Bash-Snippets" # Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" # username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
2017-07-24 17:15:19 +02:00
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) # always grabs the tag without the v option
2017-07-24 17:15:19 +02:00
if [[ ${currentVersion} == "" || ${repositoryName} == "" || ${githubUserName} == "" || ${nameOfInstallFile} == "" ]]; then
echo "Error: update utility has not been configured correctly." >&2
exit 1
2017-07-24 17:15:19 +02:00
elif [[ ${latestVersion} == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
2017-07-24 17:15:19 +02:00
if [[ "${latestVersion}" != "${currentVersion}" ]]; then
echo "Version ${latestVersion} available"
echo -n "Do you wish to update ${repositoryName} [Y/n]: "
read -r answer
2017-07-24 17:15:19 +02:00
if [[ "${answer}" == [Yy] ]]; then
cd ~ || { echo 'Update Failed'; exit 1; }
if [[ -d ~/${repositoryName} ]]; then rm -r -f ${repositoryName} || { echo "Permissions Error: try running the update as sudo"; exit 1; }; fi
git clone "https://github.com/$githubUserName/${repositoryName}" || { echo "Couldn't download latest version"; exit 1; }
cd ${repositoryName} || { echo 'Update Failed'; exit 1; }
git checkout "v${latestVersion}" 2> /dev/null || git checkout "${latestVersion}" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh # this might be necessary in your case but wasn't in mine.
./${nameOfInstallFile} "update" || exit 1
cd ..
2017-07-24 17:15:19 +02:00
rm -r -f ${repositoryName} || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/${repositoryName} delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
2017-07-24 17:15:19 +02:00
echo "${repositoryName} is already the latest version"
fi
fi
}
makeqr()
{
2017-07-24 17:15:19 +02:00
input=$(echo ${input} | sed s/" "/%20/g ) ## replace all spaces in the sentence with HTML-encoded space %20
httpGet qrenco.de/${input} ## get a response for the qrcode
}
makeMultiLineQr()
{
2017-07-24 17:15:19 +02:00
if [[ ${configuredClient} != "curl" ]]; then ## prevent usage without curl it is unreliable
2017-07-06 02:11:03 +02:00
echo "Multiline currently only supports curl!"
return 1
else
printf "%s" "$*" | curl -F-=\<- qrenco.de
fi
}
checkInternet()
{
httpGet github.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query github with a get request
}
usage()
{
2017-07-24 17:15:19 +02:00
cat <<EOF
Qrify
Description: Converts strings or URLs into a QR code.
Usage: qrify [stringtoturnintoqrcode]
-u Update Bash-Snippet Tools
-m Enable multiline support (feature not working yet)
-h Show the help
-v Get the tool version
Examples:
qrify this is a test string
qrify -m two\\\\nlines
qrify github.com (no http:// or https://)
EOF
}
getConfiguredClient || exit 1
2017-07-24 17:15:19 +02:00
while getopts "m:hvu*:" option
do
case "${option}" in
2017-07-24 17:15:19 +02:00
v) echo "Version ${currentVersion}" && exit 0 ;;
u) checkInternet && update && exit 0 || exit 1 ;;
h) usage && exit 0 ;;
2017-07-24 17:15:19 +02:00
m) multiline="1" && echo "Error this is not a supported feature yet" && exit 1 ;;
*) usage && exit 0 ;;
esac
done
if [[ $# == "0" ]]; then
usage
exit 0
2017-07-24 17:15:19 +02:00
elif [[ ${1} == "help" ]]; then
usage
exit 0
2017-07-24 17:15:19 +02:00
elif [[ ${1} == "update" ]]; then
checkInternet || exit 1
update || exit 1
exit 0
else
2017-07-24 17:15:19 +02:00
if [[ ${multiline} == "0" ]]; then
checkInternet || exit 1
input=$(printf '%s ' "$@")
makeqr || exit 1
exit 0
else
checkInternet || exit 1
2017-07-07 02:45:59 +02:00
makeMultiLineQr "${@:2}" || exit 1 ## if multiline that means a flag existed so start from the second argument
exit 0
fi
fi